{{ File Upload to SD card with PropTerminal }}

CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  SDpin = 0

VAR
  long filename
  long srcname
  byte buffer[16]

OBJ
  sd  : "fsrw"                'SD card File System
  ser : "FullDuplexSerial"

PUB main
  srcname := string("D:\Elektro\Propeller\Numbers.spin") 'Path and Filename of Sourcefile
  filename := string("NEWFILE.BIN")    'name of the file on SD card
  
  sd.mount(SDpin)                'Start SD card
  ser.start(31,30,0,115200)      'Serial start

  waitcnt(clkfreq*2+cnt)
  ser.tx(0)
  ser.str(string("Upload File to SD card:",13))
  ser.str(string("Press F1 for start",13))

  repeat until ser.rx == $D0     'wait for F1
  getFile                        'Upload

  ser.str(string(13,"done!",13))
  repeat  


PRI getFile  | b, len, n, i

  \sd.popen(filename,"w")                  'open SD card to write
  waitcnt(clkfreq/4+cnt)

  ser.tx(0)                                'request download sequence:
  ser.str(srcname)                         'send filename
  ser.str(string(5,$82))                   'initiate upload
  ser.tx(strsize(srcname))
  ser.tx("f")
  ser.rxflush  

  b := ser.rxtime(100)                     'PropTerm sends first the FileLength (4 bytes)
  if b => 0
    len := b
    b := ser.rxtime(10)  
    len |= b<<8
    b := ser.rxtime(10)  
    len |= b<<16
    b := ser.rxtime(10)  
    len |= b<<24
    
    n := 0                                 'counter for received bytes
    ser.tx(".")                            'trigger sending of first 16 bytes
    repeat
      repeat i from 0 to 15                'receive 16 bytes
        b := ser.rxtime(1000)
        if b<0 or n+i==len                 'quit if length reached
          quit
        buffer[i] := b                     'store in buffer
      if b<0
        quit
      \sd.pwrite(@buffer,16)               'write the buffer to the SD card
      if n+i=>len
        quit
      ser.tx(".")                          'trigger next 16 bytes
      n += 16

    \sd.pclose                             'all done
